package cpcns.utils;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;

public class DynamicClassLoader extends ClassLoader {
  private static final String SUFFIX = ".class";
  
  public String[] paths;
  
  public DynamicClassLoader(String[] paths) {
    this.paths = paths;
  }
  
  public DynamicClassLoader(ClassLoader parent, String[] paths) {
    super(parent);
    this.paths = paths;
  }
  
  protected Class<?> findClass(String className) throws ClassNotFoundException {
    String classPath = getClassPath(className);
    if (classPath != null) {
      byte[] clazz = loadClazz(classPath);
      return defineClass(clazz, 0, clazz.length);
    } 
    System.out.println("class is not found !");
    return null;
  }
  
  public byte[] loadClazz(String classPath) {
    try {
      FileInputStream in = new FileInputStream(new File(classPath));
      ByteArrayOutputStream baos = new ByteArrayOutputStream();
      int b;
      while ((b = in.read()) != -1)
        baos.write(b); 
      in.close();
      return baos.toByteArray();
    } catch (Exception e) {
      System.out.println(e);
      return null;
    } 
  }
  
  public String getClassPath(String className) {
    byte b;
    int i;
    String[] arrayOfString;
    for (i = (arrayOfString = this.paths).length, b = 0; b < i; ) {
      String path = arrayOfString[b];
      if (className.contains("."))
        className = className.replaceAll(".", File.separator); 
      String classPath = String.valueOf(path) + className + ".class";
      File classFile = new File(classPath);
      if (classFile.exists())
        return classPath; 
      b++;
    } 
    return null;
  }
}
